/*
Copyright © 2020 NAME HERE <EMAIL ADDRESS>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
package cmd

import (
	"fmt"
	"github.com/mhewedy/vermin/vms"
	"os"

	"github.com/spf13/cobra"
)

// psCmd represents the ps command
var psCmd = &cobra.Command{
	Use:   "ps",
	Short: "List VMs",
	Long: `List VMs
Use the -a|--all flag to list all VMs
Use the -f|--filter flag to filter VMs based on the name, image and tags (contains and AND filter)
`,
	Run: func(cmd *cobra.Command, args []string) {

		all, _ := cmd.Flags().GetBool("all")
		filters, _ := cmd.Flags().GetStringArray("filter")

		ps, err := vms.Ps(all, filters)
		if err != nil {
			fmt.Println(err)
			os.Exit(1)
		}
		fmt.Print(ps)
	},
}

func init() {
	rootCmd.AddCommand(psCmd)

	// Here you will define your flags and configuration settings.

	// Cobra supports Persistent Flags which will work for this command
	// and all subcommands, e.g.:
	// psCmd.PersistentFlags().String("foo", "", "A help for foo")

	// Cobra supports local flags which will only run when this command
	// is called directly, e.g.:
	psCmd.Flags().BoolP("all", "a", false, "List all VMs")
	psCmd.Flags().StringArrayP("filter", "f", []string{}, "Filter VMs")
}
